/* delayed-setting-view.c generated by valac 0.40.4, the Vala compiler
 * generated from delayed-setting-view.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_DELAYED_SETTING_VIEW (delayed_setting_view_get_type ())
#define DELAYED_SETTING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELAYED_SETTING_VIEW, DelayedSettingView))
#define DELAYED_SETTING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewClass))
#define IS_DELAYED_SETTING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELAYED_SETTING_VIEW))
#define IS_DELAYED_SETTING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELAYED_SETTING_VIEW))
#define DELAYED_SETTING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewClass))

typedef struct _DelayedSettingView DelayedSettingView;
typedef struct _DelayedSettingViewClass DelayedSettingViewClass;
typedef struct _DelayedSettingViewPrivate DelayedSettingViewPrivate;
enum  {
	DELAYED_SETTING_VIEW_0_PROPERTY,
	DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY,
	DELAYED_SETTING_VIEW_NUM_PROPERTIES
};
static GParamSpec* delayed_setting_view_properties[DELAYED_SETTING_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _DelayedSettingView {
	GtkGrid parent_instance;
	DelayedSettingViewPrivate * priv;
};

struct _DelayedSettingViewClass {
	GtkGridClass parent_class;
};

struct _DelayedSettingViewPrivate {
	GtkLabel* key_name_label;
	GtkLabel* key_value_label;
	GtkLabel* key_value_default;
	GtkLabel* planned_value_label;
	GtkLabel* planned_value_default;
	GtkButton* cancel_change_button;
	gchar* _full_name;
};


static gpointer delayed_setting_view_parent_class = NULL;

GType delayed_setting_view_get_type (void) G_GNUC_CONST;
#define DELAYED_SETTING_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewPrivate))
DelayedSettingView* delayed_setting_view_new (const gchar* _full_name,
                                              gboolean is_default_or_ghost,
                                              const gchar* cool_key_value,
                                              const gchar* cool_planned_value,
                                              const gchar* cool_default_value);
DelayedSettingView* delayed_setting_view_construct (GType object_type,
                                                    const gchar* _full_name,
                                                    gboolean is_default_or_ghost,
                                                    const gchar* cool_key_value,
                                                    const gchar* cool_planned_value,
                                                    const gchar* cool_default_value);
const gchar* delayed_setting_view_get_full_name (DelayedSettingView* self);
gchar* settings_model_get_name (const gchar* path);
static void delayed_setting_view_update_dconf_key (DelayedSettingView* self,
                                            gboolean is_ghost,
                                            const gchar* cool_planned_value);
static void delayed_setting_view_update_gsettings_key (DelayedSettingView* self,
                                                gboolean is_default,
                                                const gchar* cool_planned_value,
                                                const gchar* cool_default_value);
static void delayed_setting_view_set_full_name (DelayedSettingView* self,
                                         const gchar* value);
static void delayed_setting_view_finalize (GObject * obj);
static void _vala_delayed_setting_view_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_delayed_setting_view_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);


DelayedSettingView*
delayed_setting_view_construct (GType object_type,
                                const gchar* _full_name,
                                gboolean is_default_or_ghost,
                                const gchar* cool_key_value,
                                const gchar* cool_planned_value,
                                const gchar* cool_default_value)
{
	DelayedSettingView * self = NULL;
	GVariant* variant = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkButton* _tmp6_;
	GVariant* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkLabel* _tmp14_;
	g_return_val_if_fail (_full_name != NULL, NULL);
	g_return_val_if_fail (cool_key_value != NULL, NULL);
	self = (DelayedSettingView*) g_object_new (object_type, "full-name", _full_name, NULL);
	_tmp0_ = self->priv->_full_name;
	_tmp1_ = g_variant_new_string (_tmp0_);
	g_variant_ref_sink (_tmp1_);
	variant = _tmp1_;
	_tmp2_ = self->priv->key_name_label;
	_tmp3_ = self->priv->_full_name;
	_tmp4_ = settings_model_get_name (_tmp3_);
	_tmp5_ = _tmp4_;
	gtk_label_set_label (_tmp2_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = self->priv->cancel_change_button;
	_tmp7_ = variant;
	_tmp8_ = g_variant_print (_tmp7_, FALSE);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat ("ui.dismiss-change(", _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, ")", NULL);
	_tmp13_ = _tmp12_;
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp6_, _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	_tmp14_ = self->priv->key_value_label;
	gtk_label_set_label (_tmp14_, cool_key_value);
	if (cool_default_value == NULL) {
		delayed_setting_view_update_dconf_key (self, is_default_or_ghost, cool_planned_value);
	} else {
		delayed_setting_view_update_gsettings_key (self, is_default_or_ghost, cool_planned_value, (const gchar*) cool_default_value);
	}
	_g_variant_unref0 (variant);
	return self;
}


DelayedSettingView*
delayed_setting_view_new (const gchar* _full_name,
                          gboolean is_default_or_ghost,
                          const gchar* cool_key_value,
                          const gchar* cool_planned_value,
                          const gchar* cool_default_value)
{
	return delayed_setting_view_construct (TYPE_DELAYED_SETTING_VIEW, _full_name, is_default_or_ghost, cool_key_value, cool_planned_value, cool_default_value);
}


static void
delayed_setting_view_update_gsettings_key (DelayedSettingView* self,
                                           gboolean is_default,
                                           const gchar* cool_planned_value,
                                           const gchar* cool_default_value)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cool_default_value != NULL);
	if (is_default) {
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		_tmp0_ = self->priv->key_value_default;
		gtk_label_set_label (_tmp0_, _ ("Default value"));
		_tmp1_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
	} else {
		GtkLabel* _tmp2_;
		_tmp2_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
	}
	if (cool_planned_value == NULL) {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		_tmp3_ = self->priv->planned_value_label;
		gtk_label_set_label (_tmp3_, cool_default_value);
		_tmp4_ = self->priv->planned_value_default;
		gtk_label_set_label (_tmp4_, _ ("Default value"));
		_tmp5_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
	} else {
		GtkLabel* _tmp6_;
		GtkLabel* _tmp7_;
		_tmp6_ = self->priv->planned_value_label;
		gtk_label_set_label (_tmp6_, (const gchar*) cool_planned_value);
		_tmp7_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
	}
}


static void
delayed_setting_view_update_dconf_key (DelayedSettingView* self,
                                       gboolean is_ghost,
                                       const gchar* cool_planned_value)
{
	g_return_if_fail (self != NULL);
	if (is_ghost) {
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
		_tmp0_ = self->priv->key_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
		_tmp1_ = self->priv->key_value_default;
		gtk_label_set_label (_tmp1_, _ ("Key erased"));
		_tmp2_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	} else {
		GtkLabel* _tmp3_;
		_tmp3_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	}
	if (cool_planned_value == NULL) {
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
		_tmp4_ = self->priv->planned_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
		_tmp5_ = self->priv->planned_value_default;
		gtk_label_set_label (_tmp5_, _ ("Key erased."));
		_tmp6_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	} else {
		GtkLabel* _tmp7_;
		GtkLabel* _tmp8_;
		GtkLabel* _tmp9_;
		_tmp7_ = self->priv->planned_value_label;
		gtk_label_set_label (_tmp7_, (const gchar*) cool_planned_value);
		_tmp8_ = self->priv->planned_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
		_tmp9_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
	}
}


const gchar*
delayed_setting_view_get_full_name (DelayedSettingView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_full_name;
	result = _tmp0_;
	return result;
}


static void
delayed_setting_view_set_full_name (DelayedSettingView* self,
                                    const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, delayed_setting_view_get_full_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_full_name);
		self->priv->_full_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, delayed_setting_view_properties[DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY]);
	}
}


static void
delayed_setting_view_class_init (DelayedSettingViewClass * klass)
{
	gint DelayedSettingView_private_offset;
	delayed_setting_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DelayedSettingViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_delayed_setting_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_delayed_setting_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = delayed_setting_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY, delayed_setting_view_properties[DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY] = g_param_spec_string ("full-name", "full-name", "full-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	DelayedSettingView_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/delayed-setting-view.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_name_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_name_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_value_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_value_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_value_default", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_value_default));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "planned_value_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, planned_value_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "planned_value_default", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, planned_value_default));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cancel_change_button", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, cancel_change_button));
}


static void
delayed_setting_view_instance_init (DelayedSettingView * self)
{
	self->priv = DELAYED_SETTING_VIEW_GET_PRIVATE (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
delayed_setting_view_finalize (GObject * obj)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
	_g_object_unref0 (self->priv->key_name_label);
	_g_object_unref0 (self->priv->key_value_label);
	_g_object_unref0 (self->priv->key_value_default);
	_g_object_unref0 (self->priv->planned_value_label);
	_g_object_unref0 (self->priv->planned_value_default);
	_g_object_unref0 (self->priv->cancel_change_button);
	_g_free0 (self->priv->_full_name);
	G_OBJECT_CLASS (delayed_setting_view_parent_class)->finalize (obj);
}


GType
delayed_setting_view_get_type (void)
{
	static volatile gsize delayed_setting_view_type_id__volatile = 0;
	if (g_once_init_enter (&delayed_setting_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DelayedSettingViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delayed_setting_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DelayedSettingView), 0, (GInstanceInitFunc) delayed_setting_view_instance_init, NULL };
		GType delayed_setting_view_type_id;
		delayed_setting_view_type_id = g_type_register_static (gtk_grid_get_type (), "DelayedSettingView", &g_define_type_info, 0);
		g_once_init_leave (&delayed_setting_view_type_id__volatile, delayed_setting_view_type_id);
	}
	return delayed_setting_view_type_id__volatile;
}


static void
_vala_delayed_setting_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
	switch (property_id) {
		case DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY:
		g_value_set_string (value, delayed_setting_view_get_full_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_delayed_setting_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
	switch (property_id) {
		case DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY:
		delayed_setting_view_set_full_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



